\section{\uppercase{Conclusions}}\label{sec:conclusion}

In our experiments, we demonstrated the capabilities of solving systems of
polynomial equations by means of Gröbner bases and a SAT solver. Initially, we
generated systems that contain the auxiliary variables, and we saw that the
SAT solver significantly outperformed Gröbner bases. We subsequently eliminated
the auxiliary variables by a gradual substitution so that the systems contained
only the variables of the initial secret key. We saw that the results were
even worse compared to the systems with the auxiliary variables. However, when
we combined at least two systems with no auxiliary variables, we got much better
results, especially for Gröbner bases. Note, for example, that we were able to
obtain the secret key for one round of AES-128. We also solved one round of all
the other ciphers with the state array reduced.

We showed that a 16-bit version of AES reaches its full diffusion after its
third round. We also showed that the polynomial system in the third round has the
same properties as the system in the tenth round. From an algebraic
cryptanalysis point of view, this might suggest that the original AES has enough
spare rounds as well.

We tried reducing the polynomial systems without auxiliary variables by adding
similar polynomials so that equal monomials would cancel each other out, and we
also tried guessing the most frequent variables. The combination of these two
approaches allowed us to obtain the solutions for some of the systems that we
could not solve otherwise.
